<?php
class Bot {
	var $Nick;
	var $RealName;
	var $CommonConfig;

	function Bot(){
		$this->CommonCfg=array();
		$this->Nick=$this->getNick();
		$this->setInfo('bold',chr(2));
		$this->setInfo('ctcp',chr(1));
		$this->setInfo('underline',chr(31));
		$this->setInfo('reverse',chr(22));
		$this->setInfo('color',chr(3));
	}

	function getNick($id=''){
		if (empty($this->Nick) || !empty($id)){
			$Nicks=$this->getCfg('bot_nicks');
			if ($id==''){
				$NickToUse=(int)$this->getInfo('current_nick');
			}
			else {
				$NickToUse=$id;
			}

			if (empty($NickToUse)){
				$NickToUse=0;
				return $this->Nick=$Nicks[$NickToUse];
			}
			else if ($NickToUse == count($Nicks)){
				Wise_Quit("No more nick names");
				$NickToUse=0;
			}
			else {
				return $this->Nick=$Nicks[$NickToUse];
			}
			$this->setInfo('current_nick',$NickToUse);
			return '';
		}
		else {
			return $this->Nick;
		}
	}

	function getRealName(){
		if (empty($this->RealName)){
			$Names=$this->getCfg('bot_realnames');
			if ($Names==false){
				$this->RealName='I have no name';
			}
			else {
				srand((double)microtime()*10023.1);
				$NameToUse=array_rand($Names);
				$this->RealName=$Names[empty($NameToUse)?0:$NameToUse];
			}
		}
		return $this->RealName;
	}
	
	function getCfg($key){
		$data=$this->__getData($key, 'config');
		if ($data===false){
			return false;
		}
		$data=trim($data);
		if (substr($data, 0, 2)=="['" || substr($data, 0, 2)=='["'){
			$data=toArray($data); //io.php
			return $data;
		}
		else if($data==='true'){
			return true;
		}
		else if($data==='false'){
			return false;
		}
		else {
			return $data;
		}
	}

	function getInfo($key){
		$data=$this->__getData($key, 'info');
		if ($data===false){
			return false;
		}
		$data=trim($data);
		if (substr($data, 0, 2)=="['" || substr($data, 0, 2)=='["'){
			$data=toArray($data); //io.php
			return $data;
		}
		else if($data==='true'){
			return true;
		}
		else if($data==='false'){
			return false;
		}
		else {
			return $data;
		}
	}

	function setCfg($key, $value){
		return $this->__setData($key, $value, 'config');
	}

	function setInfo($key, $value){
		return $this->__setData($key, $value, 'info');
	}

	//Reload the config data by deleteing everything in the CommonCfg array
	function reload(){
		$this->CommonCfg=array();
	}

	function __getData($key, $table){
		if (empty($key) || empty($table)){
			return false;
		}

		if (!isset($this->CommonCfg[$table])){
			$this->CommonCfg[$table]=array();
		}

		//Save command config options in the CommonCfg array.  Each option has a 60 minute timeout
		//This means that after 60 minutes of being in the array, the value will be pulled again from the database.
		if (isset($this->CommonCfg[$table][$key])){
			$end=strpos($this->CommonCfg[$table][$key], chr(1));
			$time=substr($this->CommonCfg[$table][$key], 0, $end);
			if (time()-$time < 60*60){
				return substr($this->CommonCfg[$table][$key], $end+1);
			}
		}
		$key=addslashes($key);
		$Query="SELECT val FROM {$table} WHERE name='{$key}'";
		$res=db_query($Query);
		if (!$res || db_num_rows($res)==0){
			return false;
		}
		else {
			$res=db_get_row($res);
			$this->CommonCfg[$table][$key]=time().chr(1).$res->val;
			return $res->val;
		}
	}

	function __setData($key, $value, $table){
		if (empty($key) || empty($table)){
			return false;
		}

		$key=addslashes($key);
		$value=addslashes($value);

		if ($this->__getData($key, $table)===false){
			$Query="INSERT INTO $table (name,val) VALUES ('$key','$value')";
		}
		else {
			$Query="UPDATE $table SET val='$value' WHERE name='$key'";
		}
		$res=db_query($Query);
		if (!$res){
			return false;
		}
		else {
			//This is so that on the next __getData call it will retrive the new value.
			if (isset($this->CommonCfg[$table][$key])){
				unset($this->CommonCfg[$table][$key]);
			}
			return $value;
		}
	}

	//runCommand(): This function will accept as parameters the info array and the command to run.  It will check to see if:
	//		1) The person has permission to run the command
	//		2) The command exists as a file
	//	if all checks out, it sends the results of the command to the server
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//This command engine will basically, open a socket to a pre-defined area on a web server (password controlled if 
	//desired) and retrive the output of a script.  This means that phpB will no-longer run w/o a webserver, but that 
	//is alright, since a web server is recommened anyway for phpB's stats and setup.  Hopefully this will fix my 
	//problems and still be fast enough that it doesn't bog down phpB, or the computer.
	//If anyone has any other ideas, please, let me know.  What I would like is the ability to run commands in such a 
	//way that they can be edited and you don't have to restart or rehash the bot in any way.  It would be good if it
	// worked in nix and windows also.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	function runCommand($User, $INFO, $Handler){
		//First, break the command into all the sub commands and make sure that they have permission to 
		//run each command that they want to run.

		if ($Handler==true){
			return $this->runHandler($User, $INFO);
		}

		$CmdKeys=$this->getCfg('command_key');
		$FinalCommand=$INFO['MSG']; //Final Command to Run
		while (($Cmd=$this->findEmbeddedCommand($FinalCommand)) !== null){
			list($StartTick, $EndTick, $Cmd)=$Cmd;
			$Space=strpos($Cmd, ' ');
			$Space=($Space===false)?strlen($Cmd):$Space;
			$CmdName=strtolower(substr($Cmd, 0, $Space));

			if (strpos($CmdKeys, $CmdName{0}) !== false){
				$CmdName=substr($CmdName, 1);
			}

			//Check if the person has permission to run this command.
			if($INFO['BREAK_TYPE']=='NORMALMSG' && !$this->commandAllowed($User, $CmdName, $INFO['DEST'])){
				output('Access denied for user '.$User->getNick().' to command '.$CmdName);
				return false;
			}
			$INFO['EMBEDDED']=true;
			$INFO['MSG']=$Cmd;
			$results=$this->getCommandResults($User, $INFO, $CmdName, "__{$CmdName}.php");
			$TmpFinalCommand='';
			if ($StartTick){
				$TmpFinalCommand=substr($FinalCommand, 0, $StartTick-1);
			}
			$TmpFinalCommand.=$results;
			if ($EndTick != strlen($FinalCommand)){
				$TmpFinalCommand.=substr($FinalCommand, $EndTick+1);
			}
			$FinalCommand=$TmpFinalCommand;
			unset($TmpFinalCommand);
			unset($Cmd);
			unset($CmdName);
			unset($results);
		}
		$Space=strpos($FinalCommand, ' ');
		$Space=($Space===false)?strlen($FinalCommand):$Space;
		$CmdName=strtolower(substr($FinalCommand, 0, $Space));

		if (strpos($CmdKeys, $CmdName{0}) !== false){
			$CmdName=substr($CmdName, 1);
		}

		//Check if the person has permission to run this command.
		if($INFO['BREAK_TYPE']=='NORMALMSG' && !$this->commandAllowed($User, $CmdName, $INFO['DEST'])){
			output('Access denied for user '.$User->getNick().' to command '.$CmdName);
			return false;
		}

		$INFO['EMBEDDED']=false;
		$INFO['MSG']=$FinalCommand;
		$results=$this->getCommandResults($User, $INFO, $CmdName, "__{$CmdName}.php");
		$this->processResults($results);
	}

	function getCommandResults($User, $INFO, $Cmd, $file){

		//Remove any null characters.
		$file=str_replace("%00", "", $file);
		$file=str_replace(chr(0), "", $file);

		//Get the command data from the config
		$host=$this->getCfg('cmd_host');
		$port=$this->getCfg('cmd_port');
		$path=$this->getCfg('cmd_path');
		$user=$this->getCfg('cmd_user');
		$pass=$this->getCfg('cmd_pass');

		$path=$this->fixPath($path);

		//Get the extra path information if it exists
		$epath=$this->getCmdExtraPath($Cmd);
		if (!empty($epath)){
			$path.='/'.$epath;
		}

		//Serialize and encode the info array.
		foreach ($INFO as $key=>$val){
			$INFO[$key]=urlencode($val);
		}

		$PostData="INFO=".urlencode(serialize($INFO));
		if ($GLOBALS['__DEBUG__']){
			$PostData.='&debug=1';
		}

		$Auth='';
		if (!empty($user) || !empty($pass)){
			$Auth='Authorization: Basic '.base64_encode($user.":".$pass)."\r\n";
		}

		//setup the headers
		$Headers="POST $path/$file HTTP/1.0\r\n".
				"Host: $host\r\n".
				"Connection: Close\r\n".
				$Auth.
				"User-agent: Wise Command Engine v0.01\r\n".
				"Content-type: application/x-www-form-urlencoded\r\n".
				"Content-length: ".strlen($PostData)."\r\n".
				"\r\n".
				$PostData;

		//Try to open the connection to the server
		$fs=fsockopen($host, $port, $errno, $errstr, 5);
		if (!$fs){
			output("Couldn't connect to server\n");
			if ($GLOBAS['__DEBUG__']){
				output("Error: ({$errno}) {$errstr}\n");
			}
			return false;
		}
		
		if ($GLOBALS['__DEBUG__']){
			output('Sending headers.');
		}
		//We should be connected.  Send headers
		fputs($fs, $Headers);

		//Wait for response
		$results='';
		$headersDone=false;

		if ($GLOBALS['__DEBUG__']){
			output('Fetching Results.');
		}
		while ($line=fgets($fs, 1024)){
			if (preg_match("/^HTTP\/1\.. (\d{3})/",$line,$matches) && $matches[1]!='200'){
				$results='Cannot run command '.$path.'/'.$file.'. ';
				if ($matches[1]=='404'){
					$results.='No Such command';
				}
				if ($matches[1]=='401'){
					$results.="Password Required";
				}
				if ($matches[1]=='403'){
					$results.="Forbidden";
				}
				if ($matches[1]=='301'){
					$results.='Command moved';
				}
				if ($matches[1]=='302'){
					$results.='Command moved';
				}
				break;
			}
			if ($headersDone==true){
				$results.=$line;
				if ($GLOBALS['__DEBUG__']){
					output('Response so far:');
					output($results);
				}
			}
			if (trim($line)=='' && $headersDone==false){
				$headersDone=true;
			}
		}

		if ($GLOBALS['__DEBUG__']){
			output('Got Results:');
			output($results);
		}

		if ($headersDone==false){
			return false;
		}
		else {
			$results=trim($results);
			return $results;
		}
	}

	function processResults($results){
		if ($results == '' ){
			return false;
		}
		//Parse the results for some codes.

		$MaxLines=intval($this->getCfg('maximum_output_lines'));
		$MaxLineLen=intval($this->getCfg('maximum_output_line_length'));
		if ($MaxLineLen==0){
			$MaxLineLen=350;
		}
		if ($MaxLines==0){
			$MaxLines=8;
		}
		$LineCount=0;
		//First split into an array
		$results=explode("\n",$results);
		foreach ($results as $line){
			if ($LineCount >= $MaxLines){
				output("Maximum line output reached.");
				return false;
			}
			if (empty($line)){
				continue;
			}
			if ($line{0}==':'){
				$end=strpos($line, ':', 2)-1;
				$code=substr($line, 1, $end);
				$data=substr($line, $end+2);
				switch($code){
					case 'EVAL':{
						eval(urldecode($data));
						break;
					}
					case 'SLEEP':{
						if(empty($data)){
							$data=2;
						}
						$data=intval($data);
						if ($data>10){
							$data=10;
						}
						output("sleeping $data seconds");
						sleep($data);
						break;
					}
					case 'RELOAD':{
						$this->reload();
						break;
					}
					case 'CANCEL':{
						$GLOBALS['Info']['RUNABLE']=false;
					}
				}
			}
			else {
				$LineCount++;
				if (strlen($line) > $MaxLineLen){
					$line=substr($line, 0, $MaxLineLen);
				}
				msgServer($line);
			}
		}
		return true;
	}

	function runHandler($User, $INFO){
		$Cmd=$INFO['CODE'];
		if ($Cmd=='000'){
			$Cmd=$INFO['TYPE'];
		}
	
		$results=$this->getCommandResults($User, $INFO, $Cmd, "..{$Cmd}.php");
		$this->processResults($results);
	
		return true;
	}

	//commandAllowed(): This will check the database to see if the command specified can be run the the person 
	//		that wants to run it.
	function commandAllowed($User, $Cmd, $chan, $notify=true){
		$res=db_query("SELECT CmdAccess FROM commands WHERE CmdName='$Cmd'");
		if (!$res || db_num_rows($res)==0){
			return true;
		}
		if ($User->getNick()==$this->getNick()){
			return true;
		}

		$res=db_get_row($res);
		$CmdModes=toArray($res->CmdAccess);

		if (count($CmdModes)==0){
			return true;
		}

		$pass=false;
		foreach ($CmdModes as $Mode){
			if ($User->hasMode($Mode)==true || $User->hasMode('MASTER')==true){
				$pass=true;
			}
		}

		if ($pass==true && $User->isLoggedIn()==true){
			return true;
		}
		else if ($pass==true && $User->isLoggedIn()==false){
			if ($notify){
				if ($this->getDest($chan, $User->getNick())==$chan){
					Wise_Msg($chan, "Login first");
				}
				else {
					Wise_Notice($User->getNick(), "Login first");
				}
			}
			return false;
		}
		else {
			return false;
		}
	}

	function cmdExists($Cmd, $Handler=false){
		if (empty($Cmd)){
			output("No command specified in cmdExists() call");
			return false;
		}
		if ($this->getCfg('file_exists_check')==true){
			$path=$this->getCfg('file_sys_path');
			if (empty($path)){
				return true;
			}

			$path=$this->fixPath($path);
			$path=$this->fixPath($path.'/'.$this->getCmdExtraPath($Cmd));
			
			var_dump('CMD Path: '.$path);
			if ($Handler){
				$path=$path.'/..'.$Cmd.'.php';
			}
			else {
				$path=$path.'/__'.$Cmd.'.php';
			}
			//output('Checking '.$path."\n");
			return file_exists($path);
		}
		else if ($Handler){
			return true;
		}
		else {
			$res=db_query("SELECT 1 FROM commands WHERE CmdName='$Cmd'");
			if (!$res || db_num_rows($res)==0){
				//output('Doesn\'t exist in db.');
				return false;
			}
			else {
				return true;
			}
		}
	}

	function getCmdExtraPath($Cmd){
		if (is_null($Cmd)){
			return '';
		}
		$res=db_query("SELECT CmdExtraPath FROM commands WHERE CmdName='{$Cmd}' AND CmdExtraPath IS NOT NULL");
		if ($res && db_num_rows($res)>=1){
			$row=db_get_row($res);
			$path=$row->CmdExtraPath;
			//Remove trailing / or \ if they put it on the path.
			$path=$this->fixPath($path);
			$end=strlen($path)-1;
			return $this->fixPath($path);
		}
		return '';
	}
	//Run modules that people may have installed.
	//function getCommandResults($User, $INFO, $Cmd, $file){
	function runModules($Info){
		$results=NULL;
		//Select all the module names from the database.
		$res=db_query("SELECT ModDir, ModTypes, KeyWords FROM modules");
		if (!$res){
			return false;
		}

		while ($row=db_get_row($res)){
			$types=toArray($row->ModTypes);
			$keywords=toArray($row->KeyWords);
			//output('Running handlers for the modules.');
			foreach ($types as $type){
				//output('Checking if we need to run '.$type);
				if ($type{0}=='+'){
					//output('Forced run, does it match the current action?');
					$type=substr($type, 1);
					if ($type==$Info['TYPE'] || $type==$Info['BREAK_TYPE'] || $type==$Info['CODE']){
						$directory='mods/'.$row->ModDir.'/..'.$type.'.php';
						//output('Forced run of '.$directory);
						$results=$this->getCommandResults(NULL, $Info, NULL, $directory);
						$this->processResults($results);
					}
				}
				else if (!empty($type) && ($type==$Info['TYPE'] || $type==$Info['BREAK_TYPE'] || $type==$Info['CODE'])){
					if (count($keywords) > 0){
						foreach ($keywords as $word){
							if (strpos($Info['MSG'], $word) !== false){
								$directory='mods/'.$row->ModDir.'/..'.$type.'.php';
								$results=$this->getCommandResults(NULL, $Info, NULL, $directory);
								$this->processResults($results);
								break;
							}
						}
						if (!empty($results)){
						//	output('$Msg is: "'.$Info['MSG'].'"');
						//	output('No keywords found from list: '.implode(' -=- ', $keywords));
						}
					}
					else {
						$directory='mods/'.$row->ModDir.'/..'.$type.'.php';
						$results=$this->getCommandResults(NULL, $Info, NULL, $directory);
						$this->processResults($results);
					}
				}
			}
		}
		return true;
	}

	//logInfo(): Stores the info about the user in the database.
	function logInfo($Info, $User){
		if ($Info['BREAK_TYPE']=='SERVERCODE' || $Info['BREAK_TYPE']=='SERVERNOTICE'){
			return false;
		}
		else if ($Info['BREAK_TYPE']=='NORMALMSG'){
			$User->setProperty('Ident', $Info['IDENT']);
			$User->setProperty('Hostmask', $Info['HOST']);
			if ($Info['TYPE']=='QUIT' || $Info['TYPE']=='PART' || $Info['TYPE']=='KICK'){
				$User->setProperty('Online', 'N');
				$User->setProperty('LoggedIn', 'N');
			}
			else {
				$User->setProperty('Online', 'Y');
			}
			$User->setProperty('LAction', time());
			if (Channel::exists($Info['DEST'])){
				$User->setProperty('LActionText', '<'.$Info['NICK'].'> '.addslashes($Info['MSG']));
			}
			return true;
		}
		else {
			return false;
		}
	}

	//getDest(): This will take the destination of a message and see if it's the same as the bot name
	//		Used to decide if a message should go to a channel or the sender
	function getDest($Dest, $Nick){
		if (strToUpper($Dest)==strToUpper($this->getNick())){
			return $Nick;
		}
		else {
			return $Dest;
		}
	}

	
	function findEmbeddedCommand($cmdString){
		$inQuotes=false;
		$inBackticks=false;
		$firstTick=0;
		$length=strlen($cmdString);

		for ($i=0; $i<$length; $i++){
			$char=$cmdString{$i};
			if ($char=='"' || $char=="'"){
				if ($inQuotes && $cmdString{$i}==$lastQuote){
					$inQuotes=false;
				}
				else if (!$inQuotes){
					$inQuotes=true;
					$lastQuote=$char;
				}
			}
			else if (!$inQuotes && $char=='`'){
				if (!$inBackticks){
					$firstTick=$i+1;
					$inBackticks=true;
				}
				else {
					$cmd=substr($cmdString, $firstTick, $i-$firstTick);
					return array($firstTick, $i, $cmd);
				}
			}
		}
		return null;
	}

	function fixPath($path){
		if ($path{strlen($path)-1}=='\\' || $path{strlen($path)-1}=='/'){
			$path=substr($path, 0, -1);
		}
		return $path;
	}

}
?>
