<?php
define("USER_WRONG_OWNER",1);
define("USER_ID_NOT_FOUND",2);
define("USER_DOESNT_EXIST",false);

class User {
	var $UserID;
	var $Nick;

	function User($who){
		$who=trim($who);
		if (empty($who)){ return; }
		if (!is_numeric($who)){
			$who=addslashes($who);
			$res=db_query("SELECT NickID FROM users WHERE Nick='{$who}'");
			if ($res && db_num_rows($res)==0){
				User::Add($who);
				$res=db_query("SELECT NickID FROM users WHERE Nick='$who'");
			}
			$row=db_get_row($res);
			$who=$row->NickID;
		}
		$res=db_query("SELECT NickID, Nick FROM users WHERE NickID='{$who}'");
		$row=db_get_row($res);
		$this->UserID=$row->NickID;
		$this->Nick=$row->Nick;
	}

	function Exists($user){
		if (is_numeric($user)){
			$UserExists=db_query("SELECT NickID FROM users WHERE NickID='{$user}'");
			if ($UserExists && db_num_rows($UserExists)>=1){
				return true;
			}
			return false;
		}

		$user=addslashes($user);
		$UserExists=db_query("SELECT NickID FROM users WHERE Nick='{$user}'");
		if ($UserExists && db_num_rows($UserExists)>=1){
			return true;
		}
		return false;
	}

	function Add($who){
		if (!$this->Exists($who)){
			if (ereg("^[0-9]+$",$who)){
				$res=db_query("INSERT INTO users (NickID) VALUES ('$who');");
				if (!$res || db_affected_rows()==0){
					return false;
				}
			}
			else {
				$res=db_query("INSERT INTO users (Nick) VALUES ('$who');");
				if (!$res || db_affected_rows()==0){
					return false;
				}
			}
		}
		return true;
	}

	function Delete($who=''){
		if (empty($who)){
			if (empty($this->UserID)){ return false; }
			$who=$this->UserID;
		}
		if (!ereg("^[0-9]+$",$who)){
			$res=db_query("SELECT NickID FROM users WHERE Nick='{$who}'");
			$row=db_get_row($res);
			$who=$row->NickID;
		}
		$res=db_query("DELETE FROM users WHERE NickID='{$who}'");
		$rows=db_affected_rows();
		return ($rows!=0)?true:false;
	}

	function setInfo($name, $val){
		if (!empty($name) && !empty($val)){
			if ($this->getInfo($name) !== false){
				$query="INSERT INTO extra_user_info(NickID, name, val) VALUES ('{$this->UserID}', '{$name}', '{$val}')";
			}
			else {
				$query="UPDATE extra_user_info SET val='{$val}' WHERE NickID='{$this->UserID}' AND name='{$name}'";
			}
			$res=db_query($query);
			if (!$res || db_affected_rows()==0){
				return false;
			}
			return true;
		}
		return false;
	}

	function getInfo($name){
		if (!empty($name)){
			$query="SELECT val FROM extra_user_info WHERE NickID='{$this->UserID}' AND name='{$name}'";
			$res=db_query($query);
			if (!$res || db_num_rows($res)==0){
				return false;
			}
			else if (db_num_rows($res)==1){
				$row=db_get_row($res);
				return $row->val;
			}
			else {
				$return=array();
				while ($row=db_get_row($res)){
					$return[]=$row->val;
				}
				return $return;
			}
		}
		return false;
	}

	function totalUsers(){
		//Ment to be called as User::totalUsers()
		$res=db_query("SELECT COUNT(NickID) as c FROM users");
		if (!$res || db_num_rows($res)==0){
			return 0;
		}
		else {
			$res=db_get_row($res);
			return $res->c;
		}
	}

	function totalDNSUsers(){
		//Ment to be called as User::totalUsers()
		$res=db_query("SELECT COUNT(NickID) as c FROM users WHERE Hostmask IS NOT NULL");
		if (!$res || db_num_rows($res)==0){
			return 0;
		}
		else {
			$res=db_get_row($res);
			return $res->c;
		}
	}

	function totalRegistered(){
		//Ment to be called as User::totalUsers()
		$res=db_query("SELECT COUNT(NickID) as c FROM users WHERE Pass IS NOT NULL");
		if (!$res || db_num_rows($res)==0){
			return 0;
		}
		else {
			$res=db_get_row($res);
			return $res->c;
		}
	}

	function getNick(){
		return $this->Nick;
	}
	
	function getID(){
		return $this->UserID;
	}
	
	function isLoggedIn(){
		$loggedin=$this->getProperty('LoggedIn');
		return $loggedin=='Y';
	}

	function isOnline(){
		$online=$this->getProperty('Online');
		return $online=='Y';
	}

	function getProperty($prop){
		if (empty($prop)){ return false; }
		if (empty($this->UserID)){ return false; }

		$prop=addslashes($prop);
		$res=db_query("SELECT {$prop} FROM users WHERE NickID='{$this->UserID}'");
		if ($res && db_num_rows($res)==0){
			return false;
		}
		$row=db_get_row($res, 'array');
		return $row[$prop];
	}

	function setProperty($prop, $value){
		if (empty($prop)){ return false; }
		if (empty($this->UserID)){ return false; }

		$prop=addslashes($prop);
		$value=addslashes($value);
		$res=db_query("UPDATE users SET {$prop}='{$value}' WHERE NickID='{$this->UserID}'");
		if (!$res){
			return false;
		}
		return true;
	}

	function hasMode($mode){
		$res=db_query("SELECT Modes, InheritedModes FROM users WHERE Nick='{$this->Nick}'");
		if (!$res || db_num_rows($res)==0){
			//No rows, No Modes
			return false;
		}

		$res=db_get_row($res);
		$Modes=toArray($res->Modes);
		$Modes=array_merge($Modes, toArray($res->InheritedModes));

		if (count($Modes)==0){
			//No Modes
			return false;
		}

		if (in_array($mode, $Modes)){
			return true;
		}
		else {
			return false;
		}
	}
	
	function getModesArray(){
		return toArray($this->getProperty('Modes'));
	}
	
	function isRegged(){
		if ($this->getProperty('Pass')==''){
			return false;
		}
		return true;
	}
	
	function login($OtherUser){
		$this->setProperty('Loggedin','Y');
		$this->setProperty('InheritedModes','');
		if (is_object($OtherUser)){
			$Modes=toArrayString($OtherUser->getModesArray());
			$this->setProperty('InheritedModes',$Modes);
		}
	}

	function logoff(){
		$this->setProperty('Loggedin','N');
		$this->setProperty('InheritedModes','');
	}
}
?>
