
DROP TABLE IF EXISTS channels;
CREATE TABLE channels (
  ChanID int(10) unsigned NOT NULL auto_increment,
  Name varchar(50) NOT NULL default '',
  Topic text,
  TopicDate int(10) unsigned default NULL,
  TopicName varchar(30) default NULL,
  Modes varchar(25) default NULL,
  PRIMARY KEY  (ChanID)
) TYPE=MyISAM;

DROP TABLE IF EXISTS chanusers;
CREATE TABLE chanusers (
  NickID int(10) unsigned NOT NULL default '0',
  ChanID int(10) unsigned NOT NULL default '0',
  Status char(3) NOT NULL default ''
) TYPE=MyISAM;

DROP TABLE IF EXISTS commands;
CREATE TABLE commands (
  CMDID int(10) unsigned NOT NULL auto_increment,
  CmdName varchar(25) NOT NULL default '',
  CmdAccess text,
  CmdExtraPath varchar(255) default NULL,
  PRIMARY KEY  (CMDID)
) TYPE=MyISAM;

INSERT INTO commands VALUES (NULL,'001',NULL,NULL);
INSERT INTO commands VALUES (NULL,'307',NULL,NULL);
INSERT INTO commands VALUES (NULL,'311',NULL,NULL);
INSERT INTO commands VALUES (NULL,'324',NULL,NULL);
INSERT INTO commands VALUES (NULL,'332',NULL,NULL);
INSERT INTO commands VALUES (NULL,'353',NULL,NULL);
INSERT INTO commands VALUES (NULL,'433',NULL,NULL);
INSERT INTO commands VALUES (NULL,'addcmd','MASTER',NULL);
INSERT INTO commands VALUES (NULL,'exit','MASTER',NULL);
INSERT INTO commands VALUES (NULL,'join','BOT_OP',NULL);
INSERT INTO commands VALUES (NULL,'kick','BOT_OP',NULL);
INSERT INTO commands VALUES (NULL,'mode','BOT_OP',NULL);
INSERT INTO commands VALUES (NULL,'part','BOT_OP',NULL);
INSERT INTO commands VALUES (NULL,'pass','',NULL);
INSERT INTO commands VALUES (NULL,'quit',NULL,NULL);
INSERT INTO commands VALUES (NULL,'raw','BOT_OP',NULL);
INSERT INTO commands VALUES (NULL,'register',NULL,NULL);
INSERT INTO commands VALUES (NULL,'reload','BOT_OP',NULL);
INSERT INTO commands VALUES (NULL,'stats',NULL,NULL);
INSERT INTO commands VALUES (NULL,'topic',NULL,NULL);
INSERT INTO commands VALUES (NULL,'umode','MASTER',NULL);
INSERT INTO commands VALUES (NULL,'say','[\'R\']',NULL);
INSERT INTO commands VALUES (NULL,'me','[\'R\']',NULL);


DROP TABLE IF EXISTS help;
CREATE TABLE help (
  topic VARCHAR(50) NOT NULL,
  help TEXT NOT NULL
);

INSERT INTO help VALUES ('addcmd', 'addcmd -- Adds a new command to the database of commands.\nUsage: !addcmd CmdName CmdExtraPath');
INSERT INTO help VALUES ('exit', 'exit -- Shutdown the bot.\nUsage: !exit [quit message]');
INSERT INTO help VALUES ('join', 'join -- Make bot join a channel.\nUsage: !join channel');
INSERT INTO help VALUES ('kick', 'kick -- Kick a user from a channel.\nUsage: !kick user [message] [channel]');
INSERT INTO help VALUES ('mode', 'mode -- Make the bot alter user or channel mdes.\nUsage: !mode (+|-)modes (user|channel)');
INSERT INTO help VALUES ('part', 'part -- Make the bot part a channel.\nUsage: !part [channel]');
INSERT INTO help VALUES ('pass', 'pass -- Login to the bot.\nUsage: /msg <BotNick> pass [-u nick] password');
INSERT INTO help VALUES ('raw', 'raw -- Have the bot run a raw IRC command.\nUsage: !raw command');
INSERT INTO help VALUES ('register', 'register -- Register yourself with the bot.\nUsage: /msg <BotNick> register password');
INSERT INTO help VALUES ('reload', 'reload -- Make the bot reload it\'s configuration information.\nUsage: !reload');
INSERT INTO help VALUES ('stats', 'stats -- Get some statistics about the bot.\nUsage: !stats');
INSERT INTO help VALUES ('topic', 'topic -- Have the bot change the topic of a channel.\nUsage: !topic [channel] topic');
INSERT INTO help VALUES ('umode', 'umode -- Add or remove bot user modes on users.\nUsage: !umode [+|-]MODE user');
INSERT INTO help VALUES ('say', 'say -- Have the bot say something.\nUsage: !say [target] message');
INSERT INTO help VALUES ('me', 'me -- Have the bot say something in the form of /me.\nUsage: !me [target] message');


DROP TABLE IF EXISTS config;
CREATE TABLE config (
  name varchar(50) default NULL,
  val text,
  HelpDesc varchar(50) default NULL,
  UNIQUE KEY name (name)
) TYPE=MyISAM;

INSERT INTO config VALUES ('bot_nicks','[\'Wiser\',\'Wiser-Than-You\']','Bot nick names');
INSERT INTO config VALUES ('con_timeout','5','Connection Timeout');
INSERT INTO config VALUES ('bot_realnames','[\'Wiser\',\'Wiser-Than-You\']','Whois/Real names');
INSERT INTO config VALUES ('output_logging','true','Output Logging');
INSERT INTO config VALUES ('output_log_prefix','logs/Wiser_','Output log filename prefix');
INSERT INTO config VALUES ('current_server','13','Current Server ID');
INSERT INTO config VALUES ('cmd_host','','Command Server Host');
INSERT INTO config VALUES ('cmd_port','','Command Server port #');
INSERT INTO config VALUES ('cmd_user','','Command Server Username');
INSERT INTO config VALUES ('cmd_pass','','Command Server Pass');
INSERT INTO config VALUES ('cmd_path','/','Command Server directory');
INSERT INTO config VALUES ('command_key','~','Channel command triggers');
INSERT INTO config VALUES ('auto_join','[\'\']','Auto-join channels');
INSERT INTO config VALUES ('onconnect','[\'\']','Actions performed on connect');
INSERT INTO config VALUES ('file_exists_check','false','Local file exists check?');
INSERT INTO config VALUES ('file_sys_path','cmds','Local file system path');
INSERT INTO config VALUES ('ident_using_services','true','Ident to bot using services');
INSERT INTO config VALUES ('server_reconnect','true','Reconnect to server?');
INSERT INTO config VALUES ('server_retry','10','Reconnect Tries');
INSERT INTO config VALUES ('command_limit_timeout','.5','Time between commands<BR>(Minutes)');
INSERT INTO config VALUES ('auto_rejoin','true','Rejoin channels on kick');
INSERT INTO config VALUES ('maximum_output_lines','15','Max Allowed Output<BR>from Commands');
INSERT INTO config VALUES ('max_output_line_length','300','Max output line length.');

DROP TABLE IF EXISTS extra_user_info;
CREATE TABLE extra_user_info (
  NickID int(10) unsigned NOT NULL default '0',
  name varchar(50) NOT NULL default '',
  val varchar(255) default NULL
) TYPE=MyISAM;

DROP TABLE IF EXISTS info;
CREATE TABLE info (
  name varchar(50) default NULL,
  val text,
  UNIQUE KEY name (name)
) TYPE=MyISAM;

DROP TABLE IF EXISTS modules;
CREATE TABLE modules (
  ModID int(10) unsigned NOT NULL auto_increment,
  ModTypes varchar(100) default NULL,
  ModDir varchar(255) default NULL,
  ModName varchar(255) default NULL,
  KeyWords varchar(255) NOT NULL default '',
  PRIMARY KEY  (ModID)
) TYPE=MyISAM;

DROP TABLE IF EXISTS offline_cmds;
CREATE TABLE offline_cmds (
  ID int(10) unsigned NOT NULL auto_increment,
  RawLine text NOT NULL,
  TimeStamp int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

DROP TABLE IF EXISTS servers;
CREATE TABLE servers (
  ServerID int(10) unsigned NOT NULL auto_increment,
  Server varchar(255) default NULL,
  PRIMARY KEY  (ServerID)
) TYPE=MyISAM;



INSERT INTO servers VALUES (NULL,'jade.va.us.dal.net:6667');
INSERT INTO servers VALUES (NULL,'tiscali.uk.eu.dal.net:7001');
INSERT INTO servers VALUES (NULL,'astro.ga.us.dal.net:6667');
INSERT INTO servers VALUES (NULL,'coins.kl.my.dal.net:6667');
INSERT INTO servers VALUES (NULL,'acool-e.ga.us.dal.net:6667');
INSERT INTO servers VALUES (NULL,'toronto.on.ca.dal.net:6667');
INSERT INTO servers VALUES (NULL,'elysium.ga.us.dal.net:6667');
INSERT INTO servers VALUES (NULL,'matrix.de.eu.dal.net:6667');
INSERT INTO servers VALUES (NULL,'omen.se.eu.dal.net:6667');
INSERT INTO servers VALUES (NULL,'mesra-e.kl.my.dal.net:6667');
INSERT INTO servers VALUES (NULL,'anthony.freenode.net:6667');
INSERT INTO servers VALUES (NULL,'calvino.freenode.net:6667');
INSERT INTO servers VALUES (NULL,'brunner.freenode.net:6667');
INSERT INTO servers VALUES (NULL,'irc.freenode.net:6667');
INSERT INTO servers VALUES (NULL,'gibson.freenode.net:6667');
INSERT INTO servers VALUES (NULL,'leguin.freenode.net:6667');
INSERT INTO servers VALUES (NULL,'sterling.freenode.net:6667');


DROP TABLE IF EXISTS users;
CREATE TABLE users (
  NickID int(10) unsigned NOT NULL auto_increment,
  Nick varchar(32) NOT NULL default '',
  Ident varchar(10) default NULL,
  Hostmask varchar(255) default NULL,
  Pass varchar(32) default NULL,
  LoggedIn enum('Y','N') NOT NULL default 'N',
  Online enum('Y','N') NOT NULL default 'N',
  LAction int(10) unsigned default NULL,
  LActionText text,
  Modes text NOT NULL,
  InheritedModes text NOT NULL,
  PRIMARY KEY  (NickID)
) TYPE=MyISAM;
